<?php
/**
 * Created by JetBrains PhpStorm.
 * User: jorgefonseca
 * Date: 27/07/13
 * Time: 12:06
 * To change this template use File | Settings | File Templates.
 */

namespace Folha\Logic\Cadastros;


use Doctrine2\ORM\EntityManager;
use Folha\Logic\Cadastros;

class Vinculo {

    private $vinculom;
    /** @var  $vinculoh \GpevinculohEntity */
    private $vinculoh;
    private $nrorg;

    const ATIVIDADE_NORMAL = 1;
    const WINDOW = 'gpe_vinculom_wnd_mixed';
    const TAB_SALARIO           = 'gpe_altesalario';
    const TAB_MOVIMENTACAO      = 'gpe_movimentacao';

    public function __construct($nrorg) {
        $this->nrorg = $nrorg;
    }

    /**
     * @return \GpevinculomEntity
     */
    public function getVinculom()
    {
        return $this->vinculom;
    }

    public function setVinculom($vinculo)
    {
        $this->vinculom = $vinculo;
    }

    /**
     * @return \GpevinculohEntity
     */
    public function getVinculoh()
    {
        return $this->vinculoh;
    }

    public function novo($nrPessoa, $dtAdmissaoVinculo, $cdMatricula, $nrTipoVinculom, $nrTipoAdmissao,
                         $nrVinculoEmpregaticio, $dtOpcaoFGTS, $dtAposentadoriaFGTS, $dtPrimeiraAdmissao,$nmVinculom,
                         $nrDiasContratoExp, $nrDiasContratoExpPro, $dtExameMedico, $dtmescompetenc, $nrsitufuncm,
                         $nrcargo, $nrescalatrabm, $idcontribuisind, $nrdependir, $nrdependsfam, $dtbaseferias,
                         $idremuneracao, $idtppagamento, $nrestrutlegal, $nrestrutgeren, $nrtpmodalidsal, $idmultvinc,
                         $nrfuncao, $cdcontribindividual, $nrtpmovtransfm, $dtfimcontrdetermin, $nrestrutsind,
                         $confidencial = null)
    {
        try {
        $this->novoMestre(
            $nrPessoa, $dtAdmissaoVinculo, $cdMatricula, $nrTipoVinculom, $nrTipoAdmissao, $nrVinculoEmpregaticio,
            $dtOpcaoFGTS, $dtAposentadoriaFGTS, $dtPrimeiraAdmissao, $nmVinculom, $nrDiasContratoExp,
            $nrDiasContratoExpPro, $dtExameMedico
        );
        $this->novoHistorico(
            $this->getVinculom()->getNrvinculom(), $dtmescompetenc, $nrsitufuncm, $nrcargo, $nrescalatrabm,
            $idcontribuisind, $nrdependir, $nrdependsfam, $dtbaseferias, $idremuneracao, $idtppagamento, $nrestrutlegal,
            $nrestrutgeren, $nrtpmodalidsal, $idmultvinc, $nrfuncao, $cdcontribindividual, $nrtpmovtransfm,
            $dtfimcontrdetermin, $nrestrutsind, $confidencial
        );
        } catch (\Exception $e) {
            tk_warning('Problema ao inserir cadastros.');
            $connection->rollBack();
            throw $e;
        }
    }

    private function novoMestre($nrPessoa, $dtAdmissaoVinculo, $cdMatricula, $nrTipoVinculom, $nrTipoAdmissao,
                                       $nrVinculoEmpregaticio, $dtOpcaoFGTS, $dtAposentadoriaFGTS, $dtPrimeiraAdmissao,
                                       $nmVinculom, $nrDiasContratoExp, $nrDiasContratoExpPro, $dtExameMedico)
    {
        $this->vinculom = new \GpevinculomEntity();

        $this->setDadosPrincipaisVMestre(
            $nrPessoa, $dtAdmissaoVinculo, $cdMatricula, $nrTipoVinculom, $nrTipoAdmissao, $nrVinculoEmpregaticio,
            $nmVinculom
        );

        $this->setDadosExtrasVMestre(
            $dtOpcaoFGTS, $dtAposentadoriaFGTS, $dtPrimeiraAdmissao, $nrDiasContratoExp, $nrDiasContratoExpPro, $dtExameMedico
        );
        $this->vinculom->persist();

        if(!$cdMatricula){
            $this->vinculom->setCdmatricula($this->vinculom->getNrvinculom());
            $this->vinculom->persist();
        }
    }

    public function novoHistorico($nrvinculom, $dtmescompetenc, $nrsitufuncm, $nrcargo, $nrescalatrabm,
                                         $idcontribuisind, $nrdependir, $nrdependsfam, $dtbaseferias, $idremuneracao,
                                         $idtppagamento, $nrestrutlegal, $nrestrutgeren, $nrtpmodalidsal, $idmultvinc,
                                         $nrfuncao, $cdcontribindividual, $nrtpmovtransfm, $dtfimcontrdetermin,
                                         $nrestrutsind, $confidencial)
    {
        $this->vinculoh = new \GpevinculohEntity();

        $this->vinculoh->setNrorg($this->nrorg);
        $this->vinculoh->setNrvinculom($nrvinculom);
        $this->vinculoh->setDtmescompetenc($dtmescompetenc);

        $this->vinculoh->setDtbaseferias($dtbaseferias);
        $this->vinculoh->setIdmultvinc($idmultvinc);
        $this->vinculoh->setNrsitufuncm($nrsitufuncm);
        $this->vinculoh->setNrtpmovtransfm($nrtpmovtransfm);
        $this->vinculoh->setCdcontribindividual($cdcontribindividual);
        $this->vinculoh->setDtfimcontrdetermin($dtfimcontrdetermin);

        $this->vinculoh->setNrcargo($nrcargo);
        $this->vinculoh->setNrfuncao($nrfuncao);
        $this->vinculoh->setNrescalatrabm($nrescalatrabm);
        $this->vinculoh->setIdremuneracao($idremuneracao);
        $this->vinculoh->setIdtppagamento($idtppagamento);
        $this->vinculoh->setNrtpmodalidsal($nrtpmodalidsal);

        $this->vinculoh->setNrdependir($nrdependir);
        $this->vinculoh->setNrdependsfam($nrdependsfam);
        $this->vinculoh->setConfidencial($confidencial);

        $this->setDadosEstruturas($nrestrutlegal, $nrestrutgeren, $nrestrutsind, $idcontribuisind);

        $this->vinculoh->persist();
    }

    /**
     * @param $nrPessoa
     * @param $dtAdmissaoVinculo
     * @param $cdMatricula
     * @param $nrTipoVinculom
     * @param $nrTipoAdmissao
     * @param $nrVinculoEmpregaticio
     * @param $nmVinculom
     */
    private function setDadosPrincipaisVMestre($nrPessoa, $dtAdmissaoVinculo, $cdMatricula, $nrTipoVinculom,
                                               $nrTipoAdmissao, $nrVinculoEmpregaticio, $nmVinculom)
    {
        $this->vinculom->setNrorg($this->nrorg);
        $this->vinculom->setNrpessoa($nrPessoa);
        $this->vinculom->setCdmatricula($cdMatricula);
        $this->vinculom->setNmvinculom($nmVinculom);
        $this->vinculom->setDtadmissaovinc($dtAdmissaoVinculo);
        $this->vinculom->setNrtipovinculom($nrTipoVinculom);
        $this->vinculom->setNrtpadmissao($nrTipoAdmissao);
        $this->vinculom->setNrvinculoempreg($nrVinculoEmpregaticio);
    }

    /**
     * @param $dtOpcaoFGTS
     * @param $dtAposentadoriaFGTS
     * @param $dtPrimeiraAdmissao
     * @param $nrDiasContratoExp
     * @param $nrDiasContratoExpPro
     * @param $dtExameMedico
     */
    private function setDadosExtrasVMestre($dtOpcaoFGTS, $dtAposentadoriaFGTS, $dtPrimeiraAdmissao,
                                           $nrDiasContratoExp, $nrDiasContratoExpPro, $dtExameMedico)
    {
        $this->vinculom->setDtprimadmissao($dtPrimeiraAdmissao);
        $this->vinculom->setDtopcaofgts($dtOpcaoFGTS);
        $this->vinculom->setDtaposentafgts($dtAposentadoriaFGTS);
        $this->vinculom->setNrdiascontratoexp($nrDiasContratoExp);
        $this->vinculom->setNrdiascontratoexppro($nrDiasContratoExpPro);
        $this->vinculom->setDtexamemedico($dtExameMedico);
    }

    /**
     * @param $nrestrutlegal
     * @param $nrestrutgeren
     * @param $nrestrutsind
     * @param $idcontribuisind
     */
    private function setDadosEstruturas($nrestrutlegal, $nrestrutgeren, $nrestrutsind, $idcontribuisind)
    {
        $this->vinculoh->setNrestrutlegal($nrestrutlegal);
        $this->vinculoh->setNrestrutgeren($nrestrutgeren);
        $this->vinculoh->setNrestrutsind($nrestrutsind);
        $this->vinculoh->setIdcontribuisind(($idcontribuisind) ? : 'NUNCA');
    }

    public function novaAlteracaoEscala($nrEscalaTrabalho, $dtIniEscala, $observacao = null, $dtFimEscala = null,
                                        $nrhordiam = null, $nrMotivoEscala = null, $nrturno = null)
    {
        $escala = new Cadastros\Vinculo\AlteracaoEscala();
        $escala->nova(
            $this->getVinculom()->getNrvinculom(), $nrEscalaTrabalho, $dtIniEscala,
            $observacao, $dtFimEscala, $nrhordiam, $nrMotivoEscala, $nrturno, $this->nrorg
        );
        return $escala;
    }

    public function novaAlteracaoOcupacao($nrOcupacao, $dtIniOcupacao, $nrTipoOcupacao, $nrTpModalideSalario, $observacao = null,
                                          $dtFimOcupacao = null, $nrMotivoOcupacao = null, $nrNivelOcupacao = null)
    {
        $ocupacao = new Cadastros\Vinculo\AlteracaoOcupacao($this->nrorg);
        $ocupacao->nova(
            $this->getVinculom()->getNrvinculom(), $nrOcupacao, $dtIniOcupacao, $nrTipoOcupacao, $nrTpModalideSalario,
            $nrMotivoOcupacao, $nrNivelOcupacao, $dtFimOcupacao, $observacao
        );
        return $ocupacao;
    }

    public function novaAlteracaoSalario($dtAlteracaoSalario, $nrOcorrencia, $nrTipoAlteracao, $vrSalario,
                                         $idTipoSalario, $nrTipoModalideSalario, $observacao = null, $vrDiferencaReal = null,
                                         $vrPercentualReal = null, $vrpercaltera = null)
    {
        $salario = new Cadastros\Vinculo\AlteracaoSalario();
        $salario->nova(
            $this->getVinculom()->getNrvinculom(), $dtAlteracaoSalario, $nrOcorrencia, $nrTipoAlteracao, $vrSalario,
            $idTipoSalario, $nrTipoModalideSalario, $observacao, $vrDiferencaReal, $vrPercentualReal, $vrpercaltera,
            $this->nrorg
        );
        return $salario;
    }

    public function novaAlteracaoSituacao($nrSituacaoFuncionario, $dtIniSituacaoFunc)
    {
        $situacao = new Cadastros\Vinculo\AlteracaoSituacao($this->getVinculom()->getNrorg());
        $situacao->nova(
            $this->getVinculom()->getNrvinculom(), $nrSituacaoFuncionario, $dtIniSituacaoFunc
        );
        return $situacao;
    }

    public function atualizaHistoricoVinculo($nrvinculoh, $nrorg, $nrvinculom){
        /** @var  $vinculohistorico \Folha\Entities\GpeVinculoh */
        $vinculohistorico = \Folha\Entities\GpeVinculoh::findOneByNrorgAndNrvinculoh($nrorg, $nrvinculoh);
        /** @var  $altesitufunc \Folha\Entities\GpeAltesitufunc */
        $altesitufunc = \Folha\Entities\GpeAltesitufunc::findOneByNrorgAndNrvinculom($nrorg, $nrvinculom);
        $vinculohistorico->setNrsitufuncm($altesitufunc->getNrsitufuncm());
        $vinculohistorico->persist();
    }

    public function novaMovimentacao($nrTipoTransferencia, $dtInicioMovimento, $nrEstruturam, $nrTipoEstrutura,
                                     $nrTipoMovimento = null, $nrMotivoTransferencia = null, $observacao = null)
    {
        $movimentacao = new Cadastros\Vinculo\Movimentacao($this->nrorg);
        $movimentacao->nova(
            $this->getVinculom()->getNrvinculom(), $nrTipoTransferencia, $dtInicioMovimento, $nrEstruturam,
            $nrTipoEstrutura, $nrTipoMovimento, $nrMotivoTransferencia, $observacao
        );

        return $movimentacao;
     }

    public function afterInsert($nrvinculom, $nrorg){

        $competencia = \FPA::getUltimoDiaMes();

        /** @var $gpevinculom \Folha\Entities\GpeVinculom */
        $gpevinculom = \Folha\Entities\GpeVinculom::findOneByNrvinculomAndNrorg($nrvinculom, $nrorg);

        $this->setVinculom($gpevinculom);

        // inserir situação funcional;
        $situacaofuncional = $this->novaAlteracaoSituacao(self::ATIVIDADE_NORMAL, $gpevinculom->getDtadmissaovinc());

        /** @var $gpevinculoh \Folha\Entities\GpeVinculoh */
        $gpevinculoh = $gpevinculom->retornaUltimoHistoricoCompetencia($competencia);

        $gpevinculoh->setNrsitufuncm($situacaofuncional->getAlterasituacao()->getNrsitufuncm());
        $gpevinculoh->persist();

        \Setforms2\Shared\Registry::getEntityManager()->flush();

//        tk_validate_tab(self::TAB_SALARIO, self::WINDOW, 'Vínculo sem alteração salarial.', false);
//        tk_validate_tab(self::TAB_MOVIMENTACAO, self::WINDOW, 'Vínculo sem movimentação.', false);

        //todo - Melhorar mensagem;
        tk_message('Alguns processos necessitam de informações extras sobre o vínculo.<br> Por isso é importante
             que o cadastro esteja completo.<br> Clique nas abas e cadastre estas informações. ','info',false);

    }

}