<?php

/**
 * GepFluxoencasoli
 *
 * This class has been auto-generated by the Doctrine ORM Framework
 *
 * @package    DbModel
 * @subpackage Model
 * @author     alessandrobartels - 26/04/2011 10:13:47 <development@setforms.com>
 * @version    Release: SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage $
 */
class GepFluxoencasoli extends DaoGepFluxoencasoli
{


    /**
     * Consulta os dados de um fluxo de encaminhamento de uma determinada solicita??o.
     *
     * @param integer $nrorg       N?mero da Organiza??o.
     * @param integer $solicitacao N?mero da Solicita??o.
     *
     * @return objeto | false
     */
    public static function consultaDadosEncaminhamento($nrorg, $solicitacao){
        try {
            $obj = self::getObjectsByWhere(
                'NRORG = ? AND NRSOLICITACAO = ?',
                array(
                 $nrorg,
                 $solicitacao,
                )
            );

            return $obj;
        } catch(Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**
     * Consulta o ultimo dado de um fluxo de encaminhamento de uma determinada solicita??o.
     *
     * @param integer $nrorg       N?mero da Organiza??o.
     * @param integer $solicitacao N?mero da Solicita??o.
     *
     * @return objeto | false
     */
    public static function consultaUltimoDadoEncaminhamento($nrorg, $solicitacao){
        try {
            $obj = self::getObjectByWhere(
                'NRORG = ? AND NRSOLICITACAO = ?',
                array(
                 $nrorg,
                 $solicitacao,
                )
            );

            return $obj;
        } catch(Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**    ok                                                                                                           OBS: Nao esta considerando os tipos de fluxo
     * Sql do fluxo da solicitacao.                                                                                     que o operador tem acesso.
     * 
     * @param integer $nrorg Numero da organizacao.
     * 
     * @return string
     */
    static function sqlFluxoSoli($nrorg){
        $sql = "SELECT GEP_FLUXOENCASOLI.NRFLUXOENCASOLI,
                       GEP_FLUXOENCASOLI.DTINCLUSAO,
                       GEP_FLUXOENCASOLI.NRSOLICITACAO,
                       S.DSREFERENCIASOLI,
                       GEP_FLUXOENCASOLI.NRPARCOPERRESP,
                       P.NMPRINCIPALPARC,
                       GEP_FLUXOENCASOLI.NRPERFILACESSORESP,
                       A.NMPERFILACESSO,
                       GEP_FLUXOENCASOLI.NRTIPOSOLIANTE,
                       TIPOSOLIANTE.NMTIPOSOLICITACAO AS NMTIPOSOLIANTE,
                       GEP_FLUXOENCASOLI.NRSITUACAOANTE,
                       CASE
                         WHEN SITUACAOANTE.NMSITUACAO IS NULL
                          THEN 'Em elaboração'
                         ELSE SITUACAOANTE.NMSITUACAO
                       END AS NMSITUACAOANTE,
                       GEP_FLUXOENCASOLI.NRTIPOSOLIPROX,
                       TIPOSOLIPROX.NMTIPOSOLICITACAO AS NMTIPOSOLIPROX,
                       GEP_FLUXOENCASOLI.NRSITUACAOPROX,
                       CASE
                         WHEN SITUACAOPROX.NMSITUACAO IS NULL
                         THEN 'Em elaboração'
                         ELSE SITUACAOPROX.NMSITUACAO
                       END AS NMSITUACAOPROX,
                       GEP_FLUXOENCASOLI.NRMOTIVOFLUXO,
                       GEP_FLUXOENCASOLI.TXLOGFLUXOSOLI,
                       GEP_FLUXOENCASOLI.CDOPERULTATU,
                       O.NMOPERADOR,
                       GEP_FLUXOENCASOLI.TXOBSERVFLUXOSOLI,
                       GEP_FLUXOENCASOLI.NRORG
                  FROM GEP_FLUXOENCASOLI
             LEFT JOIN GEP_SOLICITACAO S ON (S.NRSOLICITACAO = GEP_FLUXOENCASOLI.NRSOLICITACAO)
                                        AND (S.NRORG = GEP_FLUXOENCASOLI.NRORG)
             LEFT JOIN PARCNEGOCIO P ON (P.NRPARCNEGOCIO = GEP_FLUXOENCASOLI.NRPARCOPERRESP)
                                    AND (P.NRORG = GEP_FLUXOENCASOLI.NRORG)
             LEFT JOIN PERFILACESSO A ON (A.NRPERFILACESSO = GEP_FLUXOENCASOLI.NRPERFILACESSORESP)
                                     AND (A.NRORG = GEP_FLUXOENCASOLI.NRORG)
             LEFT JOIN GEP_SITUACAO SITUACAOANTE ON (SITUACAOANTE.NRSITUACAO = GEP_FLUXOENCASOLI.NRSITUACAOANTE)
                                                 AND (SITUACAOANTE.NRORG = GEP_FLUXOENCASOLI.NRORG)
             LEFT JOIN GEP_SITUACAO SITUACAOPROX ON (SITUACAOPROX.NRSITUACAO = GEP_FLUXOENCASOLI.NRSITUACAOPROX)
                                                 AND (SITUACAOPROX.NRORG = GEP_FLUXOENCASOLI.NRORG)
             LEFT JOIN GEP_TIPOSOLICITACAO TIPOSOLIANTE ON (TIPOSOLIANTE.NRTIPOSOLICITACAO = GEP_FLUXOENCASOLI.NRTIPOSOLIANTE)
                                                       AND (TIPOSOLIANTE.NRORG = GEP_FLUXOENCASOLI.NRORG)
             LEFT JOIN GEP_TIPOSOLICITACAO TIPOSOLIPROX ON (TIPOSOLIPROX.NRTIPOSOLICITACAO = GEP_FLUXOENCASOLI.NRTIPOSOLIPROX)
                                                       AND (TIPOSOLIPROX.NRORG = GEP_FLUXOENCASOLI.NRORG)
             LEFT JOIN OPERADOR O ON (O.CDOPERADOR = GEP_FLUXOENCASOLI.CDOPERINCLUSAO)
                                 AND (O.NRORG = GEP_FLUXOENCASOLI.NRORG)
             WHERE S.NRORG = $nrorg
               AND WHERE_PLACEHOLDER
               AND FILTER_PLACEHOLDER
          ORDER BY GEP_FLUXOENCASOLI.NRFLUXOENCASOLI DESC";

        return $sql;
    }


}