import {
  Loader, Http, Metadata, IDictionary, IEventParam, Config,
} from '@zeedhi/core';

import {
  Form, LoadingService, List, Select, Tabs, GridEditable, Checkbox,
} from '@zeedhi/common';
import { PmeMask, PmeCurrencyMask } from '@/config';
import { CrudForm } from '@zeedhi/teknisa-components-common';
  
export class Pla01900ParametrosPlanejamentoController {
  // Utils
  
  private utilities = Loader.getInstance('Utilities');
  
  public appController = Loader.getInstance('AppController');

  public gridEditController = Loader.getInstance('GridEditableController');
  
  public crudController = Loader.getInstance('CrudController');
  
  // Parâmetros da paramgeral
  
  private idautperfacesso = '';
  
  private idblopratloc = true;
  
  private idbloqpradup = false;
  
  private qtDiaBloqCar = '';
  
  private cdcabohidra = '';
  
  private cdproteina = '';
  
  private cdalcool = '';
  
  private cdlipidios = '';
  
  private cdcalorias = '';
  
  private cdacidgraxos = '';
  
  private cdacucares = '';
  
  private idutrpadca = false;
  
  private paramGeralDict = {};
  
  // Parâmetros da paramplaneja e filial
  
  private filialFilterValue = '';
  
  private unidadeAnterior = '';
  
  private idcardiautil = '';
  
  private idconsgrprat = '';
  
  private idservincfilagr = '';
  
  private idcuspadcar = '';
  
  private cdservretpme = '';
  
  private cdnutrrelat1 = '';
  
  private cdnutrrelat2 = '';
  
  private cdnutrrelat3 = '';
  
  private cdnutrrelat4 = '';
  
  private idprinvenreti = '';
  
  private cdtpretipadr = '';
  
  private cdtipocustorea = '';
  
  private cdtipocustopla = '';
  
  private idexibecusto = '';
  
  private idperccome = '';
  
  private txmenscardia = '';
  
  private txmenscarsem = '';
  
  private cdtcaconsper = '';
  
  private cdtcaconsfix = '';
  
  private idqtliqubrut = '';
  
  private nrcorcardesp: any = '';
  
  private nrcornutil: any = '';
  
  private nrcornalte: any = '';
  
  private nrcorsafra: any = '';
  
  private nrcorinicsaf: any = '';
  
  private nrcorentrsaf: any = '';
  
  private idcomcusperc = '';
  
  private paramPlanejaDict = {};
  
  private idutretbaseinve = '';
  
  private paramGrupOper = {};
  
  private fieldByParam = {
    ALTRECEPADRAO: {
      label: 'Autorização de Alterações em Receitas Padrões',
      nameField: 'DSGROPERREPA',
      value: 'CDGROPERREPA',
    },
  };
  
  // Form

  public submitFunc() {
    const tabPrincipal: Tabs = Metadata.getInstance('principalTabParametros');
    const activeTab = tabPrincipal.activeTab;
    const tabCard: Tabs = Metadata.getInstance('subTabGeral');

    if (tabCard.activeTab === 0) {
      if (activeTab === 0) this.submitParametrosPlanGeralCard();
      else this.submitParametrosPlaneja();
    }
  }

  public returnActiveTab() {
    if (document.getElementsByName('subTabParametros').length > 0) {
      const subTabPlaneja: Tabs = Metadata.getInstance('subTabParametros');
      const activeSubTab = subTabPlaneja.activeTab;
      const arrayHelper = ['Planejamento', 'Elaboracao', 'MensCard', 'ConfPrato',
        'ReqRetirada', 'SafraCard', 'calculoNDPCAL'];
      const nameActive = arrayHelper[activeSubTab];
      
      return nameActive;
    }
    return undefined;
  }
  
  public visibleParam() {
    if (document.getElementsByName('CDFILIAL').length > 0 && document.getElementsByName('IDUTRETBASEINVE').length > 0) {
      const cdfilial = Metadata.getInstance<Select>('CDFILIAL');
      const idut = Metadata.getInstance<Checkbox>('IDUTRETBASEINVE');
      // IDFILCENTPME == CDFILIAL && IDTPFILIALCENT == 'M'
      idut.isVisible = true;
      if (cdfilial.selectValue.IDFILCENTPME === 'S' && cdfilial.selectValue.IDTPFILIALCENT === 'M') {
        idut.disabled = false;
      } else {
        idut.disabled = true;
        if (cdfilial.selectValue.CENTRAL) {
          this.utilities.getParamFilial(cdfilial.selectValue.CENTRAL).then((paramfilial: IDictionary) => {
            if (paramfilial.IDUTRETBASEINVE === 'S') idut.value = 'S';
            else idut.value = 'N';
          });
        } else idut.value = 'N';
      }
      this.controlIdPrin();
    }
  }
  
  public controlIdPrin() {
    if (document.getElementsByName('IDPRINVENRETI').length > 0 && document.getElementsByName('IDUTRETBASEINVE').length > 0) {
      const idprin = Metadata.getInstance<Checkbox>('IDPRINVENRETI');
      const idut = Metadata.getInstance<Checkbox>('IDUTRETBASEINVE');
      if (idut.value === 'S') idprin.disabled = false;
      else idprin.disabled = true;
    }
  }
  
  public cancelFunc() {
    const tabPrincipal: Tabs = Metadata.getInstance('principalTabParametros');
    const activeTab = tabPrincipal.activeTab;
    
    if (activeTab === 0) this.cancelFormGeral();
    else this.cancelFormPlaneja();
  }
  
  public reloadParamGeral() {
    this.getParamGeral();
  }
  
  public reloadParamPlaneja() {
    this.getParamPlanejaEFilial();
  }
  
  public reloadGrupOper() {
    this.getParamGrupOper();
  }
  
  public cancelFormGeral() {
    this.reloadParamGeral();
    // this.closeListGroup('groupListCardapio');
    // this.openListGroup('groupListCardapio');
  }
  
  public cancelFormPlaneja() {
    this.getParamUnidadePla();
  }
  
  public cancelFormSafra() {
    this.getParamUnidadeSafra();
  }
  
  public cancelFormElaboracao() {
    this.getParamUnidadeElaboracao();
  }
  
  public cancelFormMensagem() {
    this.getParamUnidadeMensagem();
  }
  
  public cancelFormReqRetirada() {
    this.getParamUnidadeReqRetirada();
  }
  
  public cancelFormConfPrato() {
    this.getParamUnidadeConfPrato();
  }
  
  public cancelFormGrupOper() {
    this.getGrupOper();
  }
  
  public changeFieldPlaneja({ component }: IDictionary) {
    if (!(this.filialFilterValue)) Metadata.getInstance<Form>('formUnidade').validate();
    if (component.component === 'ZdRadio') {
      let form: CrudForm;
      if (component.parent.name === 'formTabPlanejamentoEla') {
        form = Metadata.getInstance<CrudForm>('formTabPlanejamentoEla');
      } else if (component.parent.name === 'formTabPlanejamentoConfPrato') {
        form = Metadata.getInstance<CrudForm>('formTabPlanejamentoConfPrato');
      } else form = Metadata.getInstance<CrudForm>('formTabPlanejamento');
      form.editing = true;
    }
  }
  
  get disabledButtonsGeral() {
    const form = Metadata.getInstance<CrudForm>('formTabCardapio');
    return !form.editing;
  }
  
  get disabledButtonsGrupOper() {
    const form = Metadata.getInstance<CrudForm>('formTabGruoOper');
    return !form.editing;
  }
  
  get disabledButtonsPlaneja() {
    const form = Metadata.getInstance<CrudForm>('formTabPlanejamento');
    return !form.editing;
  }
  
  get disabledButtonsSafra() {
    const form = Metadata.getInstance<CrudForm>('formTabPlanejamentoSafraCard');
    return !form.editing;
  }
  
  get disabledButtonsElaboracao() {
    const form = Metadata.getInstance<CrudForm>('formTabPlanejamentoEla');
    return !form.editing;
  }
  
  get disabledButtonsMensagem() {
    const form = Metadata.getInstance<CrudForm>('formTabPlanejamentoMensCard');
    return !form.editing;
  }
  
  get disabledButtonsReqRetirada() {
    const form = Metadata.getInstance<CrudForm>('formTabPlanejamentoReqRetirada');
    return !form.editing;
  }
  
  get disabledButtonsConfPrato() {
    const form = Metadata.getInstance<CrudForm>('formTabPlanejamentoConfPrato');
    return !form.editing;
  }
  
  private callLoading() {
    LoadingService.show(' ');
    window.setTimeout(() => LoadingService.hide(), 1000);
    window.setTimeout(() => this.utilities.showAlert('alert', 'Salvo com sucesso!', 'success'), 1100);
  }
  
  private closeListGroup(nameComponent: string) {
    const listElement: List = Metadata?.getInstance(nameComponent);
    
    if (listElement) listElement.childrenInstances.forEach((ele) => { ele.opened = false; });
  }
  
  /* private openListGroup(nameComponent: string) {
    const listElement: List = Metadata?.getInstance(nameComponent);
    
    if (listElement) listElement.childrenInstances.forEach((ele) => { ele.opened = true; });
  } */
  
  // Filters
  
  public setFilterFilial({ component }: IEventParam<Select>) {
    const filter = [
      {
        name: 'CDFILCENTPME',
        operator: '=',
        value: this.filialFilterValue,
      },
    ];
    
    component.datasource.filter = filter;
    component.datasource.get();
  }
  
  public setFilterServicoRet({ component }: IEventParam<Select>) {
    const filter = [
      {
        name: 'CDFILIAL',
        operator: '=',
        value: this.filialFilterValue,
      },
    ];
    
    component.datasource.filter = filter;
    component.datasource.get();
  }
  
  public setFilialLogada({ component }: IDictionary) {
    if (!(component.value)) component.value = localStorage.getItem('CDFILIALLOGADA');
  }
  
  // Getters
  
  public async getParamGeral() {
    let data;
    let paramgeral = await Http.get('/paramgeral');
    if (paramgeral.data.data.length === 0) {
      paramgeral = await Http.get('/insereParamgeral', {});
      await Http.get('/insereGERParamgeral', {});
      data = paramgeral.data.dataset.data;
    } else {
      data = paramgeral.data.data[0];
      if (!data.GERPARGERAL) await Http.get('/insereGERParamgeral', {});
    }
    
    // this.loadingDataSourceSelects();
    
    const cdcarbohidra = Metadata.getInstance<Select>('CDCARBOHIDRA');
    const cdproteina = Metadata.getInstance<Select>('CDPROTEINA');
    const cdalcool = Metadata.getInstance<Select>('CDALCOOL');
    const cdlipidios = Metadata.getInstance<Select>('CDLIPIDIOS');
    const cdcalorias = Metadata.getInstance<Select>('CDCALORIAS');
    const cdacidgraxos = Metadata.getInstance<Select>('CDACIDGRAXOS');
    const cdacucares = Metadata.getInstance<Select>('CDACUCARES');
    const gets = [
      cdcarbohidra.datasource.get(),
      cdproteina.datasource.get(),
      cdalcool.datasource.get(),
      cdlipidios.datasource.get(),
      cdcalorias.datasource.get(),
      cdacidgraxos.datasource.get(),
      cdacucares.datasource.get(),
    ];
    
    await Promise.all(gets);

    const form = Metadata.getInstance<CrudForm>('formTabCardapio');
    form.setValue(
      {
        IDAUTPERFACESSO: data.NRPERFILACESSO,
        CDCARBOHIDRA: data.CDCARBOHIDRA,
        CDPROTEINA: data.CDPROTEINA,
        CDALCOOL: data.CDALCOOL,
        CDLIPIDIOS: data.CDLIPIDIOS,
        CDCALORIAS: data.CDCALORIAS,
        CDACIDGRAXOS: data.CDACIDGRAXOS,
        CDACUCARES: data.CDACUCARES,
        IDUTRPADCA: data.IDUTRPADCA,
        QTDIABLOQCAR: data.QTDIABLOQCAR,
        IDBLOPRATLOC: data.IDBLOPRATLOC,
        IDBLOQPRADUP: data.IDBLOQPRADUP,
        IDPERMSELCENTRALPLA: data.IDPERMSELCENTRALPLA,
      },
    );
    
    setTimeout(() => {
      form.editing = false;
    }, 1200);
  }
  
  // public loadingDataSourceSelects() {
  //   const cdcarbohidra = Metadata.getInstance<Select>('CDCARBOHIDRA');
  //   const cdproteina = Metadata.getInstance<Select>('CDPROTEINA');
  //   const cdalcool = Metadata.getInstance<Select>('CDALCOOL');
  //   const cdlipidios = Metadata.getInstance<Select>('CDLIPIDIOS');
  //   const cdcalorias = Metadata.getInstance<Select>('CDCALORIAS');
  //   const cdacidgraxos = Metadata.getInstance<Select>('CDACIDGRAXOS');
  //   const cdacucares = Metadata.getInstance<Select>('CDACUCARES');
  //   const gets = {
  //     cdcarbohidra.datasource.get();
  //     cdproteina.datasource.get();
  //     cdalcool.datasource.get();
  //     cdlipidios.datasource.get();
  //     cdcalorias.datasource.get();
  //     cdacidgraxos.datasource.get();
  //     cdacucares.datasource.get();
  //   }
    
  //   return gets;
  // }
  
  public getGrupOper() {
    const form = Metadata.getInstance<CrudForm>('formTabGruoOper');
    
    form.setValue(
      {
        IDAUTPERFACESSO: this.idautperfacesso,
      },
    );
    
    setTimeout(() => {
      form.editing = false;
    }, 300);
  }
  
  public getParamUnidadePla() {
    const form = Metadata.getInstance<CrudForm>('formTabPlanejamento');
    form.setValue(
      {
        IDCARDIAUTIL: this.idcardiautil,
        IDCONSGRPRAT: this.idconsgrprat,
        IDSERVINCFILAGR: this.idservincfilagr,
        IDCUSPADCAR: this.idcuspadcar,
        IDCOMCUSPERC: this.idcomcusperc,
        CDNUTRRELAT1: this.cdnutrrelat1,
        CDNUTRRELAT2: this.cdnutrrelat2,
        CDNUTRRELAT3: this.cdnutrrelat3,
        CDNUTRRELAT4: this.cdnutrrelat4,
        IDUTRETBASEINVE: this.idutretbaseinve,
        IDPRINVENRETI: this.idprinvenreti,
        CDTPRETIPADR: this.cdtpretipadr,
        CDSERVRETPME: this.cdservretpme,
      },
    );
    
    setTimeout(() => {
      form.editing = false;
    }, 1500);
  }
  
  public getParamUnidadeSafra() {
    if (document.getElementsByName('formTabPlanejamentoSafraCard').length > 0) {
      const form = Metadata.getInstance<CrudForm>('formTabPlanejamentoSafraCard');
      form.setValue(
        {
          NRCORINICSAF: this.nrcorinicsaf,
          NRCORENTRSAF: this.nrcorentrsaf,
          NRCORSAFRA: this.nrcorsafra,
          NRCORNALTE: this.nrcornalte,
          NRCORNUTIL: this.nrcornutil,
          NRCORCARDESP: this.nrcorcardesp,
        },
      );
      
      setTimeout(() => {
        form.editing = false;
      }, 600);
    }
  }
  
  public getParamUnidadeElaboracao() {
    if (document.getElementsByName('formTabPlanejamentoEla').length > 0) {
      const form = Metadata.getInstance<CrudForm>('formTabPlanejamentoEla');
      form.setValue(
        {
          CDTIPOCUSTOPLA: this.cdtipocustopla,
          CDTIPOCUSTOREA: this.cdtipocustorea,
          IDEXIBECUSTO: this.idexibecusto,
          IDPERCCOME: this.idperccome,
        },
      );
      
      setTimeout(() => {
        form.editing = false;
      }, 600);
    }
  }
  
  public getParamUnidadeMensagem() {
    if (document.getElementsByName('formTabPlanejamentoMensCard').length > 0) {
      const form = Metadata.getInstance<CrudForm>('formTabPlanejamentoMensCard');
      form.setValue(
        {
          TXMENSCARDIA: this.txmenscardia,
          TXMENSCARSEM: this.txmenscarsem,
        },
      );
      
      setTimeout(() => {
        form.editing = false;
      }, 300);
    }
  }
  
  public getParamUnidadeReqRetirada() {
    if (document.getElementsByName('formTabPlanejamentoReqRetirada').length > 0) {
      const form = Metadata.getInstance<CrudForm>('formTabPlanejamentoReqRetirada');
      form.setValue(
        {
          CDTCACONSPER: this.cdtcaconsper,
          CDTCACONSFIX: this.cdtcaconsfix,
        },
      );
      
      setTimeout(() => {
        form.editing = false;
      }, 600);
    }
  }
  
  public getParamUnidadeConfPrato() {
    if (document.getElementsByName('formTabPlanejamentoConfPrato').length > 0) {
      const form = Metadata.getInstance<CrudForm>('formTabPlanejamentoConfPrato');
      form.setValue(
        {
          IDQTLIQUBRUT: this.idqtliqubrut,
        },
      );
      
      setTimeout(() => {
        form.editing = false;
      }, 600);
    }
  }
  
  public getParamPlanejaEFilial() {
    if (this.filialFilterValue !== '' && this.unidadeAnterior !== this.filialFilterValue) {
      this.unidadeAnterior = this.filialFilterValue;
      this.utilities.getParamPlaneja(this.filialFilterValue).then((paramplaneja: IDictionary) => {
        this.idblopratloc = paramplaneja?.IDBLOPRATLOC;
        this.idbloqpradup = paramplaneja?.IDBLOQPRADUP;
        this.idcardiautil = paramplaneja?.IDCARDIAUTIL;
        this.idconsgrprat = paramplaneja?.IDCONSGRPRAT;
        this.idservincfilagr = paramplaneja?.IDSERVINCFILAGR;
        this.idcuspadcar = paramplaneja?.IDCUSPADCAR;
        this.cdservretpme = paramplaneja?.CDSERVRETPME;
        this.cdnutrrelat1 = paramplaneja?.CDNUTRRELAT1;
        this.cdnutrrelat2 = paramplaneja?.CDNUTRRELAT2;
        this.cdnutrrelat3 = paramplaneja?.CDNUTRRELAT3;
        this.cdnutrrelat4 = paramplaneja?.CDNUTRRELAT4;
        this.idprinvenreti = paramplaneja?.IDPRINVENRETI;
        this.cdtpretipadr = paramplaneja?.CDTPRETIPADR;
        this.cdtipocustopla = paramplaneja?.CDTIPOCUSTOPLA;
        this.cdtipocustorea = paramplaneja?.CDTIPOCUSTOREA;
        this.idexibecusto = paramplaneja?.IDEXIBECUSTO;
        this.idperccome = paramplaneja?.IDPERCCOME;
        this.txmenscardia = paramplaneja?.TXMENSCARDIA;
        this.txmenscarsem = paramplaneja?.TXMENSCARSEM;
        this.idqtliqubrut = paramplaneja?.IDQTLIQUBRUT;
        this.cdtcaconsper = paramplaneja?.CDTCACONSPER;
        this.cdtcaconsfix = paramplaneja?.CDTCACONSFIX;
        this.nrcorcardesp = this.utilities.TColorToHex(paramplaneja?.NRCORCARDESP);
        this.nrcornutil = this.utilities.TColorToHex(paramplaneja?.NRCORNUTIL);
        this.nrcornalte = this.utilities.TColorToHex(paramplaneja?.NRCORNALTE);
        this.nrcorsafra = this.utilities.TColorToHex(paramplaneja?.NRCORSAFRA);
        this.nrcorinicsaf = this.utilities.TColorToHex(paramplaneja?.NRCORINICSAF);
        this.nrcorentrsaf = this.utilities.TColorToHex(paramplaneja?.NRCORENTRSAF);
      
        this.utilities.getParamFilial(this.filialFilterValue).then((paramfilial: IDictionary) => {
          this.idcomcusperc = paramfilial?.IDCOMCUSPERC;
          this.idutretbaseinve = paramfilial?.IDUTRETBASEINVE;
        }).finally(() => {
          this.getParamUnidadePla();
          this.getParamUnidadeSafra();
          this.getParamUnidadeElaboracao();
          this.getParamUnidadeMensagem();
          this.getParamUnidadeConfPrato();
          this.getParamUnidadeReqRetirada();
        });
        
        this.visibleParam();
      });
      
      // const activeTab = this.returnActiveTab();
      // if (activeTab) this.openListGroup(`groupList${activeTab}`);
    }
  }
  
  public getParamGrupOper() {
    Http.get('/autperfilacesso').then((perfilacesso) => {
      const form = Metadata.getInstance<CrudForm>('formTabGruoOper');
      
      if (Array.isArray(perfilacesso.data.data) && perfilacesso.data.data.length) {
        const arrayPerfil = perfilacesso.data.data;
        
        arrayPerfil.forEach((item: any) => {
          if (item.IDAUTPERFACESSO === 'ALTRECEPADRAO') {
            form.setValue({ IDAUTPERFACESSO: item.NRPERFILACESSO });
            this.idautperfacesso = item.NRPERFILACESSO;
          }
        });
      }
      
      setTimeout(() => {
        form.editing = false;
      }, 300);
    });
  }
  
  // Submits
  
  public submitParametrosPlanGeralCard() {
    const formGeralCard = Metadata.getInstance<Form>('formTabCardapio');
    
    if (formGeralCard.validate()) {
      this.paramGeralDict = {
        QTDIABLOQCAR: formGeralCard.value.QTDIABLOQCAR,
        CDCARBOHIDRA: formGeralCard.value.CDCARBOHIDRA,
        CDPROTEINA: formGeralCard.value.CDPROTEINA,
        CDALCOOL: formGeralCard.value.CDALCOOL,
        CDLIPIDIOS: formGeralCard.value.CDLIPIDIOS,
        CDCALORIAS: formGeralCard.value.CDCALORIAS,
        CDACIDGRAXOS: formGeralCard.value.CDACIDGRAXOS,
        CDACUCARES: formGeralCard.value.CDACUCARES,
        IDUTRPADCA: formGeralCard.value.IDUTRPADCA,
        IDBLOPRATLOC: formGeralCard.value.IDBLOPRATLOC,
        IDBLOQPRADUP: formGeralCard.value.IDBLOQPRADUP,
        IDPERMSELCENTRALPLA: formGeralCard.value.IDPERMSELCENTRALPLA,
      };
      
      this.callPlanGeralSave(this.paramGeralDict);
    }
  }
  
  public submitParametrosPlaneja({ component }: IDictionary = []) {
    const formFilterUnidade = Metadata.getInstance<Form>('formUnidade');
    const tabName = component ? component.name : this.returnActiveTab();
    
    if (formFilterUnidade.validate()) {
      this.fillParamPlanejaDict(tabName);
      this.callPlanejaSave(this.paramPlanejaDict);
    }
  }
  
  public submitParametrosGrupOper() {
    const formGrupOper = Metadata.getInstance<Form>('formTabGruoOper');
    const unidade = Metadata.getInstance<Select>('IDAUTPERFACESSO');
    
    if (formGrupOper.validate()) {
      this.paramGrupOper = {
        permissions: this.fieldByParam,
        currentRow: unidade.value,
      };
      
      this.callPlanGrupOperSave(this.paramGrupOper);
    }
  }
  
  // Call save
  
  private callPlanGeralSave(row: IDictionary) {
    Http.post('/updateParamGeral', { requestType: 'Row', row }).then((response) => {
      if (response) {
        this.callLoading();
      }
    }).catch((error: string) => {
      this.utilities.showAlert('alert', `pme::${error}`, 'error');
    }).finally(() => {
      this.cancelFormGeral();
    });
  }
  
  private callPlanejaSave(row: IDictionary) {
    Http.post('/updateParamPlaneja', { requestType: 'Row', row }).then((response) => {
      if (response) {
        this.callLoading();
      }
    }).catch((error: string) => {
      this.utilities.showAlert('alert', `pme::${error}`, 'error');
    }).finally(() => {
      let form: CrudForm;
      if (row.tab === 'MensCard') {
        form = Metadata.getInstance<CrudForm>('formTabPlanejamentoMensCard');
        
        this.txmenscarsem = form.value.TXMENSCARSEM;
        this.txmenscardia = form.value.TXMENSCARDIA;
      } else if (row.tab === 'ReqRetirada') {
        form = Metadata.getInstance<CrudForm>('formTabPlanejamentoReqRetirada');
        
        this.cdtcaconsper = form.value.CDTCACONSPER;
        this.cdtcaconsfix = form.value.CDTCACONSFIX;
      } else if (row.tab === 'ConfPrato') {
        form = Metadata.getInstance<CrudForm>('formTabPlanejamentoConfPrato');
        
        this.idqtliqubrut = form.value.IDQTLIQUBRUT;
      } else if (row.tab === 'Elaboracao') {
        form = Metadata.getInstance<CrudForm>('formTabPlanejamentoEla');
        
        this.cdtipocustopla = form.value.CDTIPOCUSTOPLA;
        this.cdtipocustorea = form.value.CDTIPOCUSTOREA;
        this.idexibecusto = form.value.IDEXIBECUSTO;
        this.idperccome = form.value.IDPERCCOME;
      } else if (row.tab === 'Planejamento') {
        form = Metadata.getInstance<CrudForm>('formTabPlanejamento');
        
        this.idcardiautil = form.value.IDCARDIAUTIL;
        this.idconsgrprat = form.value.IDCONSGRPRAT;
        this.idservincfilagr = form.value.IDSERVINCFILAGR;
        this.idcuspadcar = form.value.IDCUSPADCAR;
        this.idcomcusperc = form.value.IDCOMCUSPERC;
        this.cdnutrrelat1 = form.value.CDNUTRRELAT1;
        this.cdnutrrelat2 = form.value.CDNUTRRELAT2;
        this.cdnutrrelat3 = form.value.CDNUTRRELAT3;
        this.cdnutrrelat4 = form.value.CDNUTRRELAT4;
        this.idutretbaseinve = form.value.IDUTRETBASEINVE;
        this.idprinvenreti = form.value.IDPRINVENRETI;
        this.cdtpretipadr = form.value.CDTPRETIPADR;
        this.cdservretpme = form.value.CDSERVRETPME;
      } else /* if (row.tab === 'SafraCard') */ {
        form = Metadata.getInstance<CrudForm>('formTabPlanejamentoSafraCard');
        
        this.nrcorcardesp = form.value.NRCORCARDESP;
        this.nrcornutil = form.value.NRCORNUTIL;
        this.nrcornalte = form.value.NRCORNALTE;
        this.nrcorsafra = form.value.NRCORSAFRA;
        this.nrcorinicsaf = form.value.NRCORINICSAF;
        this.nrcorentrsaf = form.value.NRCORENTRSAF;
      }
    
      form.editing = false;
    });
  }
  
  private callPlanGrupOperSave(row: IDictionary) {
    Http.post('/updateGrupOper', { requestType: 'Row', row }).then((response) => {
      if (response) {
        this.callLoading();
      }
    }).catch((error: string) => {
      this.utilities.showAlert('alert', `pme::${error}`, 'error');
    }).finally(() => {
      this.idautperfacesso = row.currentRow;
      const form = Metadata.getInstance<CrudForm>('formTabGruoOper');
      form.editing = false;
    });
  }
  
  // excluir
  public cancelForm() {
    return true;
  }

  // Helpers
  
  private fillParamPlanejaDict(tabName: string) {
    let form;
    if (tabName.includes('MensCard')) {
      form = Metadata.getInstance<CrudForm>('formTabPlanejamentoMensCard').value;
      
      this.paramPlanejaDict = {
        TXMENSCARSEM: form.TXMENSCARSEM,
        TXMENSCARDIA: form.TXMENSCARDIA,
        CDFILIAL: this.filialFilterValue,
        tab: 'MensCard',
      };
    } else if (tabName.includes('ConfPrato')) {
      form = Metadata.getInstance<CrudForm>('formTabPlanejamentoConfPrato').value;
      
      this.paramPlanejaDict = {
        IDQTLIQUBRUT: form.IDQTLIQUBRUT,
        CDFILIAL: this.filialFilterValue,
        tab: 'ConfPrato',
      };
    } else if (tabName.includes('ReqRetirada')) {
      form = Metadata.getInstance<CrudForm>('formTabPlanejamentoReqRetirada').value;
      
      this.paramPlanejaDict = {
        CDTCACONSPER: form.CDTCACONSPER,
        CDTCACONSFIX: form.CDTCACONSFIX,
        CDFILIAL: this.filialFilterValue,
        tab: 'ReqRetirada',
      };
    } else if (tabName.includes('Elaboracao')) {
      form = Metadata.getInstance<CrudForm>('formTabPlanejamentoEla').value;
      
      this.paramPlanejaDict = {
        CDTIPOCUSTOPLA: form.CDTIPOCUSTOPLA,
        CDTIPOCUSTOREA: form.CDTIPOCUSTOREA,
        IDEXIBECUSTO: form.IDEXIBECUSTO,
        IDPERCCOME: form.IDPERCCOME,
        CDFILIAL: this.filialFilterValue,
        tab: 'Elaboracao',
      };
    } else if (tabName.includes('Planejamento')) {
      form = Metadata.getInstance<CrudForm>('formTabPlanejamento').value;
      
      this.paramPlanejaDict = {
        IDCARDIAUTIL: form.IDCARDIAUTIL,
        IDCONSGRPRAT: form.IDCONSGRPRAT,
        IDSERVINCFILAGR: form.IDSERVINCFILAGR,
        IDCUSPADCAR: form.IDCUSPADCAR,
        IDCOMCUSPERC: form.IDCOMCUSPERC,
        CDSERVRETPME: form.CDSERVRETPME,
        CDNUTRRELAT1: form.CDNUTRRELAT1,
        CDNUTRRELAT2: form.CDNUTRRELAT2,
        CDNUTRRELAT3: form.CDNUTRRELAT3,
        CDNUTRRELAT4: form.CDNUTRRELAT4,
        IDPRINVENRETI: form.IDPRINVENRETI,
        CDTPRETIPADR: form.CDTPRETIPADR,
        CDFILIAL: this.filialFilterValue,
        IDUTRETBASEINVE: form.IDUTRETBASEINVE,
        tab: 'Planejamento',
      };
    } else if (tabName.includes('SafraCard')) {
      form = Metadata.getInstance<CrudForm>('formTabPlanejamentoSafraCard').value;
      const nrcorcardesp = this.utilities.hexToRgbInline(form.NRCORCARDESP).split('.', 3);
      const nrcornutil = this.utilities.hexToRgbInline(form.NRCORNUTIL).split('.', 3);
      const nrcornalte = this.utilities.hexToRgbInline(form.NRCORNALTE).split('.', 3);
      const nrcorsafra = this.utilities.hexToRgbInline(form.NRCORSAFRA).split('.', 3);
      const nrcorinicsaf = this.utilities.hexToRgbInline(form.NRCORINICSAF).split('.', 3);
      const nrcorentrsaf = this.utilities.hexToRgbInline(form.NRCORENTRSAF).split('.', 3);
      
      this.paramPlanejaDict = {
        NRCORCARDESP: this.utilities.RGBToTColor(nrcorcardesp[0], nrcorcardesp[1], nrcorcardesp[2]),
        NRCORNUTIL: this.utilities.RGBToTColor(nrcornutil[0], nrcornutil[1], nrcornutil[2]),
        NRCORNALTE: this.utilities.RGBToTColor(nrcornalte[0], nrcornalte[1], nrcornalte[2]),
        NRCORSAFRA: this.utilities.RGBToTColor(nrcorsafra[0], nrcorsafra[1], nrcorsafra[2]),
        NRCORINICSAF: this.utilities.RGBToTColor(nrcorinicsaf[0], nrcorinicsaf[1], nrcorinicsaf[2]),
        NRCORENTRSAF: this.utilities.RGBToTColor(nrcorentrsaf[0], nrcorentrsaf[1], nrcorentrsaf[2]),
        CDFILIAL: this.filialFilterValue,
        tab: 'SafraCard',
      };
    }
  }

  public saveCalcNDPCAL() {
    const grid = Metadata.getInstance<GridEditable>('gridCalcNDPCAL');
    const editedRows: IDictionary = grid.getEditedRows(false, true);

    if (grid.isGridValid(true) && editedRows.length > 0) {
      if (grid) grid.datasource.loading = true;
      Http.post('/saveNDPCAL', { requestType: 'Row', editedRows }).then((response) => {
        const result = response.data.dataset.saveConfigCard.type;
        if (result !== 'error') {
          this.gridEditController.defaultState(grid);
          // grid.datasource.get();
          this.utilities.showAlert('Alert', 'Salvo com sucesso!', 'success');
        } else this.utilities.showAlert('alert', 'ProdutoExistente', 'error');
      }).catch((error: string) => {
        this.utilities.showAlert('alert', `pme::${error}`, 'error');
      }).finally(() => {
        if (grid) grid.datasource.loading = false;
      });
    }
  }
  
  public produtoComponentProps = {
    menuMaxHeight: 220,
    component: 'ZdSelect',
    dataText: [
      {
        name: 'CDARVPROD',
        mask: (Config.masks.productMask as PmeMask).pattern,
      },
      'NMPRODUTO',
    ],
    formatterDataText: [
      {
        name: 'CDARVPROD',
        mask: (Config.masks.productMask as PmeMask).pattern,
      },
      'NMPRODUTO',
    ],
    dataValue: 'CDPRODUTO',
    dense: true,
    datasource: {
      uniqueKey: 'CDPRODUTO',
      route: '/find/productList',
      type: 'rest',
      limit: 10,
      lazyLoad: true,
    },
    returnObject: true,
    validations: {
      required: {
        message: 'Campo obrigatório',
      },
    },
  };
  
  public fatorCalculoMask = {
    decimalCharacter: (Config.masks.numberMask as PmeCurrencyMask).decimalCharacter,
    digitGroupSeparator: (Config.masks.numberMask as PmeCurrencyMask).digitGroupSeparator,
    decimalPlaces: 2,
  };
}
