import {
  IDictionary, Http, Metadata, Loader,
} from '@zeedhi/core';

import { GridEditable } from '@zeedhi/common';

export class Pla13200AgrupamentoGrupoPratos {
  public crudController = Loader.getInstance('CrudController');
  
  public utilities = Loader.getInstance('Utilities');
  
  public gridEditController = Loader.getInstance('GridEditableController');
  
  public save() {
    const grid: GridEditable = Metadata.getInstance('gridAgrupGrupoPratos');
    const editedRows: IDictionary = grid.getEditedRows(false, true);
    let validSave = true;
    
    if (grid.isGridValid(true)) {
      Http.post('/returnCodAgrupPratos', {}).then((response: IDictionary) => {
        const codigo = response.data.dataset.codigo[0].CODIGO;
        
        editedRows.forEach((row: IDictionary) => {
          if (row.__is_new) {
            row.NRAGRUPGRPRAT = codigo + 1;
            row.CDAGRUPGRPRAT = row.CDAGRUPGRPRAT ? row.CDAGRUPGRPRAT.padStart(10, '0') : null;
            row.NMAGRUPGRPRAT = row.NMAGRUPGRPRAT ? row.NMAGRUPGRPRAT : null;
            row.IDTIPORESTRICAO = 'CONTRATO';
          } else row.__is_new = false;
        
          grid.datasource.data.forEach((rowsGrid) => {
            if (row.__is_new) {
              if (rowsGrid.__is_new !== true && rowsGrid.CDAGRUPGRPRAT === row.CDAGRUPGRPRAT) validSave = false;
            }
          });
        });
        
        if (validSave === true && editedRows.length > 0) {
          this.crudController.saveRows(editedRows, 'agrupamentoPratos', grid).then(() => {
            this.gridEditController.cancelEditing({ component: grid });
            this.utilities.showAlert('alert', 'Salvo com sucesso!', 'success');
          }).catch((error: string) => {
            this.utilities.showAlert('alert', `pme::${error}`, 'error');
          });
        } else this.utilities.showAlert('alert', 'Impossível adicionar. Registro já existe.', 'error');
      });
    }
  }
}
